/*
 * xzx    : Copyright (c) Des Herriott 1993, 1994
 * xcoupe : Copyright (c) Allan Skillman 1995.
 *
 * Permission to use, copy, modify, distribute, and sell this software and its
 * documentation for any purpose is hereby granted without fee, provided that
 * the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name of the copyright holder not be used in
 * advertising or publicity pertaining to distribution of the software without
 * specific, written prior permission.  The copyright holder makes no
 * representations about the suitability of this software for any purpose.  It
 * is provided "as is" without express or implied warranty.
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO
 * EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
 * DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 * TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Allan Skillman (Based on xzx coding by Des Herriott)
 */

/* Header file xsamP.h - some definitions and tables used only by xsam.c */


/* Maps ASCII keys to a keyboard row and bit to set/reset */
/* E.g. ktbl['a'] means set/reset bit 0 (0xfe) of keyboard row 1 */
struct ktbl {
	int port;	/* which keyboard row is the key on? */
	int bit;	/* which bit to mask */
} keytable[128] = {
	{9, 0}, {9, 0}, {9, 0}, {9, 0}, {9, 0}, {9, 0}, {9, 0}, {9, 0}, 
	{9, 0}, {9, 0}, {9, 0}, {9, 0}, {9, 0}, {9, 0}, {9, 0}, {9, 0}, 
	{9, 0}, {9, 0}, {9, 0}, {9, 0}, {9, 0}, {9, 0}, {9, 0}, {9, 0}, 
	{9, 0}, {9, 0}, {9, 0}, {9, 0}, {9, 0}, {9, 0}, {9, 0}, {9, 0}, 
	/* SPACE ! "" # $ % & ' */
	{7, 0xfe}, {3, 0xfe}, {9, 0}, {9, 0}, {3,0xf7},
	{3,0xef}, {4,0xf7}, {9, 0},
	/* ( ) * + , - . / */
	{4, 0xfb}, {4, 0xfd}, {4, 0xbf}, {9, 0}, {9, 0}, {9, 0},
	{9, 0}, {9, 0}, 
	/* 0 1 2 3 4 5 6 7 8 9 */
	{4, 0xfe}, {3, 0xfe}, {3, 0xfd}, {3, 0xfb}, {3, 0xf7},
	{3, 0xef}, {4, 0xef}, {4, 0xf7}, {4, 0xfb}, {4, 0xfd},
	/* : ; < = > ? @ */
	{9, 0}, {9, 0}, {9, 0}, {9, 0}, {9, 0}, {9, 0}, {3, 0xfd}, 
	/* A -> Z  (upper & lower case are the same) */
	{1, 0xfe}, {7, 0xef}, {0, 0xf7}, {1, 0xfb}, {2, 0xfb}, {1, 0xf7},
	{1, 0xef}, {6, 0xef}, {5, 0xfb}, {6, 0xf7}, {6, 0xfb}, {6, 0xfd}, 
	{7, 0xfb}, {7, 0xf7}, {5, 0xfd}, {5, 0xfe}, {2, 0xfe}, {2, 0xf7},
	{1, 0xfd}, {2, 0xef}, {5, 0xf7}, {0, 0xef}, {2, 0xfd}, {0, 0xfb},
	{5, 0xef}, {0, 0xfd},
	/* [ \ ] ^ _ ` */
	{9, 0}, {9, 0}, {9, 0}, {4, 0xef}, {9, 0}, {9, 0},
	/* a -> z  (upper & lower case are the same) */
	{1, 0xfe}, {7, 0xef}, {0, 0xf7}, {1, 0xfb}, {2, 0xfb}, {1, 0xf7},
	{1, 0xef}, {6, 0xef}, {5, 0xfb}, {6, 0xf7}, {6, 0xfb}, {6, 0xfd}, 
	{7, 0xfb}, {7, 0xf7}, {5, 0xfd}, {5, 0xfe}, {2, 0xfe}, {2, 0xf7},
	{1, 0xfd}, {2, 0xef}, {5, 0xf7}, {0, 0xef}, {2, 0xfd}, {0, 0xfb},
	{5, 0xef}, {0, 0xfd},
	/* { | } ~ DEL */
	{9, 0}, {9, 0}, {9, 0}, {9, 0}, {9, 0}
};

/* The Number of Colours the SAM has */
#define NCOLORS 128

